/*$Id: d_admit.cc,v 13.32 1999/04/25 07:12:45 al Exp $ -*- C++ -*-
 * functions for admittance (type 'Y')
 * does not exist in spice
 * x = volts, y.f0 = amps, ev = y.f1 = mhos.
 */
#include "d_admit.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_ADMITTANCE::expand();
// 	bool	DEV_ADMITTANCE::dotr();
// 	void	DEV_ADMITTANCE::doac();
/*--------------------------------------------------------------------------*/
CARD& DEV_ADMITTANCE::expand()
{
  m0.f1 = y0.f1 = value();
  y0.f0 = LINEAR;
  m0.c0 = 0.;
  acg = ev = value();
  assert(loss == 0.);
  setconstant(!has_tr_eval());
  return *this;
}
/*--------------------------------------------------------------------------*/
bool DEV_ADMITTANCE::dotr()
{
  assert(!isbypassed());
  if (has_tr_eval()){
    m0.x = volts_limited(n[OUT1],n[OUT2]);
    y0.x = m0.x;
    y0.f0 = m0.f1 * m0.x + m0.c0;	/* BUG:  patch for diode */
    tr_eval();
    store_values();
    SIM::loadq.push(this);
    assert(y0.f0 != LINEAR);
    m0.x = y0.x;
    m0.c0 = y0.f0 - y0.x * y0.f1;
    m0.f1 = y0.f1;
  }else{
    untested();
    assert(y0.f0 == LINEAR);
    assert(y0.f1 == value());
    assert(m0.f1 == value());
    assert(m0.c0 == 0.);
    assert(y1 == y0);
    assert(converged());
  }
  return converged();
}
/*--------------------------------------------------------------------------*/
CARD& DEV_ADMITTANCE::doac()
{
  if (has_ac_eval()){
    untested();
    acbias = n[OUT1].vdc() - n[OUT2].vdc();
    ac_eval();
    acg = ev;
  }else if (has_tr_eval()){
    acg = ev = y0.f1;
  }else{
    assert(acg == value());
  }
  return acload_passive(); 
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
