/*$Id: main.cc,v 13.38 1999/05/13 16:27:17 al Exp $ -*- C++ -*-
 * top level module
 * it all starts here
 */
#include "patchlev.h"
#include "c_comand.h"
#include "declare.h"	/* lots */
#include "mode.h"
#include "l_jmpbuf.h"
/*--------------------------------------------------------------------------*/
	int	main(int,const char*[]);
static	void    sign_on(void);
static	void    read_startup_files(void);
static	void    process_cmd_line(int,const char*[]);
static	void	finish(void);
/*--------------------------------------------------------------------------*/
extern JMP_BUF env;
extern run_mode_t run_mode;
/*--------------------------------------------------------------------------*/
int main(int argc, const char *argv[])
{
  initialize_io();
  sign_on();
  if (setjmp(env.p)){		
    finish();			/* error clean up (from longjmp())	*/
  }else{
    read_startup_files();
    setup_traps();
    process_cmd_line(argc,argv);
  }  
  for (;;){
    char cmdbuf[BUFLEN];
    CMD::count++;
    getcmd("-->", cmdbuf, BUFLEN);
    run_mode = rEXECUTE;
    CMD::cmdproc(cmdbuf);
  }
  return 0;
}
/*--------------------------------------------------------------------------*/
static void sign_on(void)
{
  IO::mstdout << "ACS (Al's Circuit Simulator) 0." << PATCHLEVEL << '\n'
    << "Never trust any version less than 1.0\n"
    << "Copyright 1994, Albert Davis\n"
    << "ACS comes with ABSOLUTELY NO WARRANTY\n"
    << "This is free software, and you are welcome\n"
    << "to redistribute it under certain conditions.\n"
    << "See the file \"COPYING\" for details\n";
}
/*--------------------------------------------------------------------------*/
static void read_startup_files(void)
{
  char* name = findfile(SYSTEMSTARTFILE, SYSTEMSTARTPATH, R_OK);
  if (name){
    char cmdbuf[BUFLEN];
    sprintf(cmdbuf, "get %s", name);
    CMD::cmdproc(cmdbuf);
  }
  name = findfile(USERSTARTFILE, USERSTARTPATH, R_OK);
  if (name){
    char cmdbuf[BUFLEN];
    sprintf(cmdbuf, "get %s", name);
    CMD::cmdproc(cmdbuf);
  }
  CMD::cmdproc("clear");
}
/*--------------------------------------------------------------------------*/
static void process_cmd_line(int argc, const char *argv[])
{
  if (argc > 1){
    char cmdbuf[BUFLEN];
    sprintf(cmdbuf, "< %s", argv[1]);
    CMD::cmdproc(cmdbuf);
  }
}
/*--------------------------------------------------------------------------*/
/* finish: clean up after a command
 * deallocates space, closes plot windows, resets i/o redirection, etc.
 * This is done separately for exception handling.
 * If a command aborts, clean-up is still done, leaving a consistent state.
 */
static void finish(void)
{
  plclose();
  IO::suppresserrors = false;
  outreset();
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
